Loading...
Searching...
No Matches
juce::ReadWriteLock Class Reference

## Detailed Description

A critical section that allows multiple simultaneous readers.

Features of this type of lock are:

- Multiple readers can hold the lock at the same time, but only one writer can hold it at once.
- Writers trying to gain the lock will be blocked until all readers and writers have released it
- Readers trying to gain the lock while a writer is waiting to acquire it will be blocked until the writer has obtained and released it
- If a thread already has a read lock and tries to obtain a write lock, it will succeed if there are no other readers
- If a thread already has the write lock and tries to obtain a read lock, this will succeed.
- Recursive locking is supported.

See also
  ScopedReadLock, ScopedWriteLock, CriticalSection

The documentation for this class was generated from the following file:

- juce_core/threads/juce_ReadWriteLock.h

## Public Member Functions

| ReadWriteLock () noexcept
| Creates a ReadWriteLock object.
| ~ReadWriteLock () noexcept
| Destructor.
void | enterRead () const noexcept
| Locks this object for reading.
bool | tryEnterRead () const noexcept
| Tries to lock this object for reading.
void | exitRead () const noexcept
| Releases the read-lock.
void | enterWrite () const noexcept
| Locks this object for writing.
bool | tryEnterWrite () const noexcept
| Tries to lock this object for writing.
void | exitWrite () const noexcept
| Releases the write-lock.

## Constructors and Destructors

## ReadWriteLock()

juce::ReadWriteLock::ReadWriteLock | ( |  | ) |

noexcept

Creates a ReadWriteLock object.

Referenced by ~ReadWriteLock().

## ~ReadWriteLock()

juce::ReadWriteLock::~ReadWriteLock | ( |  | ) |

noexcept

Destructor.

If the object is deleted whilst locked, any subsequent behaviour is undefined.

References ReadWriteLock().

## Member Functions

## enterRead()

void juce::ReadWriteLock::enterRead | ( |  | ) | const

noexcept

Locks this object for reading.

Multiple threads can simultaneously lock the object for reading, but if another thread has it locked for writing, then this will block until it releases the lock.

See also
  exitRead, ScopedReadLock

References enterRead().

Referenced by enterRead().

## tryEnterRead()

bool juce::ReadWriteLock::tryEnterRead | ( |  | ) | const

noexcept

Tries to lock this object for reading.

Multiple threads can simultaneously lock the object for reading, but if another thread has it locked for writing, then this will fail and return false.

Returns
  true if the lock is successfully gained.

See also
  exitRead, ScopedTryReadLock

References tryEnterRead().

Referenced by tryEnterRead().

## exitRead()

void juce::ReadWriteLock::exitRead | ( |  | ) | const

noexcept

Releases the read-lock.

If the caller thread hasn't got the lock, this can have unpredictable results.

If the enterRead() method has been called multiple times by the thread, each call must be matched by a call to exitRead() before other threads will be allowed to take over the lock.

See also
  enterRead, ScopedReadLock

References exitRead().

Referenced by exitRead().

## enterWrite()

void juce::ReadWriteLock::enterWrite | ( |  | ) | const

noexcept

Locks this object for writing.

This will block until any other threads that have it locked for reading or writing have released their lock.

See also
  exitWrite, ScopedWriteLock

References enterWrite().

Referenced by enterWrite().

## tryEnterWrite()

bool juce::ReadWriteLock::tryEnterWrite | ( |  | ) | const

noexcept

Tries to lock this object for writing.

This is like enterWrite(), but doesn't block - it returns true if it manages to obtain the lock.

Returns
  true if the lock is successfully gained.

See also
  enterWrite, ScopedTryWriteLock

References tryEnterWrite().

Referenced by tryEnterWrite().

## exitWrite()

void juce::ReadWriteLock::exitWrite | ( |  | ) | const

noexcept

Releases the write-lock.

If the caller thread hasn't got the lock, this can have unpredictable results.

If the enterWrite() method has been called multiple times by the thread, each call must be matched by a call to exit() before other threads will be allowed to take over the lock.

See also
  enterWrite, ScopedWriteLock

References exitWrite().

Referenced by exitWrite().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited